//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Hsrm.EdgeGateway.GatewayService
{
    
    
    /// <summary>
    /// This feature is used to provide generic gateway functionality
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "gateway")]
    [Tecan.Sila2.SilaIdentifierAttribute("GatewayService")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Gateway Service")]
    public partial interface IGatewayService
    {
        
        /// <summary>
        /// Lists the servers connected to this gateway
        /// </summary>
        [Tecan.Sila2.ObservableAttribute()]
        System.Collections.Generic.ICollection<Server> ConnectedServers
        {
            get;
        }
        
        /// <summary>
        /// Signifies whether a new feature has been registered that requires a server restart to become available
        /// </summary>
        bool HasNewFeature
        {
            get;
        }
        
        /// <summary>
        /// Performs a network discovery for the specified duration
        /// </summary>
        /// <param name="duration">The duration for which the gateway should look for servers</param>
        void ScanNetwork([Tecan.Sila2.UnitAttribute("s", Second=1)] long duration);
        
        /// <summary>
        /// Restarts the gateway
        /// </summary>
        void Restart();
        
        /// <summary>
        /// Set the name of a connected server
        /// </summary>
        void SetServerName(string serverUuid, string name);
        
        /// <summary>
        /// Get the identifiers of the required metadata
        /// </summary>
        /// <param name="identifier">The fully qualified identifier of the command or property</param>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReturnValue")]
        System.Collections.Generic.ICollection<string> GetRequiredMetadata(string serverUuid, string identifier);
    }
    
    public struct Server
    {
        
        private string _serverUuid;
        
        private string _name;
        
        private string _type;
        
        private string _version;
        
        private string _description;
        
        private string _vendorUri;
        
        private System.Collections.Generic.ICollection<string> _features;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public Server(string serverUuid, string name, string type, string version, string description, string vendorUri, System.Collections.Generic.ICollection<string> features)
        {
            _serverUuid = serverUuid;
            _name = name;
            _type = type;
            _version = version;
            _description = description;
            _vendorUri = vendorUri;
            _features = features;
        }
        
        [Tecan.Sila2.PatternConstraintAttribute("[0-9a-f]{8}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{4}\\-[0-9a-f]{12}")]
        [Tecan.Sila2.MaximalLengthAttribute(36)]
        public string ServerUuid
        {
            get
            {
                return _serverUuid;
            }
        }
        
        public string Name
        {
            get
            {
                return _name;
            }
        }
        
        public string Type
        {
            get
            {
                return _type;
            }
        }
        
        public string Version
        {
            get
            {
                return _version;
            }
        }
        
        public string Description
        {
            get
            {
                return _description;
            }
        }
        
        public string VendorUri
        {
            get
            {
                return _vendorUri;
            }
        }
        
        public System.Collections.Generic.ICollection<string> Features
        {
            get
            {
                return _features;
            }
        }
    }
}
